#include <tscope5.h>

int main()
{
	ts5_set_coordinate_scale(TS5_RELATIVE_COORDINATES);
	ts5_set_coordinate_system(TS5_DISPLAY_COORDINATES);

	double mw, mh;
	ts5_get_display_adapter_size(1, &mw, &mh);
	
	ts5_set_display_position(0.25, 0.25);
	ts5_set_display_size(0.5, 0.5);
	
	ts5_install_display();
	
	double dw, dh;
	ts5_get_display_size(1, &dw, &dh);
	
	double dx, dy;
	ts5_get_display_position(1, &dx, &dy);
	
	TS5_BITMAP *map = ts5_alloc_bitmap(0.5, 0.5);
	
	double bw, bh;
	ts5_get_bitmap_size(map, &bw, &bh);
		
	ts5_set_background_color(ts5_make_named_color("white", 1.0));
	ts5_set_drawing_target(map);
	ts5_clear_display();
	
	ts5_set_background_color(ts5_make_named_color("black", 1.0));
	ts5_set_active_display(1);
	ts5_draw_bitmap(map, 0.25, 0.25);

	ts5_set_foreground_color(ts5_make_named_color("black", 1.0));
	ts5_printf(0.5, 0.4, "display adapter size: %.0f x %.0f", mw, mh);
	ts5_printf(0.5, 0.5, "display size: %.0f x %.0f", dw, dh);
	ts5_printf(0.5, 0.6, "display position: %.0f x %.0f", dx, dy);
	ts5_printf(0.5, 0.7, "bitmap size: %.0f x %.0f", bw, bh);
	ts5_flip_display();
			
	ts5_draw_mouse_button(0.9,0.8);
	
	ts5_free_bitmap(map);
	return 0;
}