#include <tscope5.h>
#include <stdio.h>

int main()
{
	ts5_install_display();
	ts5_set_coordinate_system(TS5_DISPLAY_COORDINATES);
	ts5_set_text_alignment(TS5_ALIGN_LEFT);
	
	// helper variable to position the scanf echo
	double w;

	// test variable that catches the return value of ts5_scanf
	// return value: number of variables that have been read successfully
	int test;

	// ask the name of the participant
	char subj[50];
    subj[0] = '\0';
	do {
        ts5_clear_display();
        w = ts5_printf(20.0, 20.0, "Name: ");
		ts5_flip_display();
        test = ts5_scanf(20.0 + w, 20.0, "%s", subj);
    } while (test != 1);
	
	
	// ask for the participants gender
	char gender = 0;
	do {
        ts5_clear_display();
        w = ts5_printf(20.0, 20.0, "Gender (m/f): ");
		ts5_flip_display();
        test = ts5_scanf(20.0 + w, 20.0, "%c", &gender);
	} while (test != 1 || (gender != 'm' && gender != 'f'));
	
	
	// ask for the participants handedness
	char hand = 0;
	do {
        ts5_clear_display();
        w = ts5_printf(20.0, 20.0, "Hand (l/r): ");
		ts5_flip_display();
        test = ts5_scanf(20.0 + w, 20.0, "%c", &hand);
	} while (test != 1 || (hand != 'l' && hand != 'r'));
	
	
	// ask for the participants age
	int age = 0;
	do {
        ts5_clear_display();
        w = ts5_printf(20.0, 20.0, "Age: ");
		ts5_flip_display();
        test = ts5_scanf(20.0 + w, 20.0, "%d", &age);
	} while (test != 1 || (age<0 || age>120));
	
	
	// print the results on the screen
	ts5_clear_display();
	char tmp1[20], tmp2[20];
    
	if (gender == 'm') {
		sprintf(tmp1, "male");
	}
	else {
		sprintf(tmp1, "female");
	}
	
	if (hand == 'l') {
		sprintf(tmp2, "left handed");
	}
	else {
		sprintf(tmp2, "right handed");
	}
	
	ts5_printf(20.0, 20.0, "%s is %d years old,", subj, age);
	ts5_printf(20.0, 40.0, "%s and %s.", tmp1, tmp2);
	
	ts5_flip_display();
	
	
 	double x = ts5_relative_to_absolute_coordinate_x(0.9);
 	double y =  ts5_relative_to_absolute_coordinate_y(0.8);	
 	ts5_draw_mouse_button(x, y);
	
	return 0;
}
