#include <tscope5.h>

int main()
{
	ts5_set_refreshrate(60);
	ts5_set_vsync_mode(TS5_VSYNC_ON);
	
	ts5_install_display();
	ts5_wait(1.0);
	
	int i;
	double fix, prime, target;
	
	for (i=0; i<5; i++) {
		
		
		// fixation
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "+");
		fix = ts5_flip_display();
	
		// prime
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "prime");
		ts5_wait(0.495); // fixation time: 0.5 seconds. wait al little less than 0.5 seconds + vsync
		prime = ts5_flip_display();
		
		// target
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "target");
		ts5_wait(0.045); // prime time: 0.05 seconds		
		target = ts5_flip_display();
		
		ts5_printf(0.0, ts5_relative_to_absolute_coordinate_y(-0.25), "fixation onset: %f", fix);
		ts5_printf(0.0, ts5_relative_to_absolute_coordinate_y(-0.35), "fixation time: %f", prime-fix);
		ts5_printf(0.0, ts5_relative_to_absolute_coordinate_y(-0.45), "prime onset: %f", prime);
		ts5_printf(0.0, ts5_relative_to_absolute_coordinate_y(-0.55), "prime time: %f", target-prime);
		ts5_flip_display();
		
		// iti
		ts5_wait_until(fix + 3.0);	
	}
	
	
	ts5_draw_mouse_button(ts5_relative_to_absolute_coordinate_x(0.9), ts5_relative_to_absolute_coordinate_y(-0.8));	
	return 0;
}