#include <tscope5.h>

int main()
{
	ts5_install_display();
	ts5_wait(2.0);
	ts5_define_keyboard_key(TS5_KEY_S);
	ts5_define_keyboard_key(TS5_KEY_L);
		
	double start, stop, rt, error;
	int i;
	for (i=0; i<5; i++) {
		
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "+");
		ts5_flip_display();
		
		unsigned int stim = ts5_random_integer(2);
		if (stim==0) {
			stim='S';
		}
		else {
			stim='L';
		}
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "%c", stim);
		ts5_wait(0.5);
		ts5_flush_responses();
		start = ts5_flip_display();
		
		int resp = ts5_wait_for_response_timed(&stop, &error, 2.0);
		rt = stop-start;
		ts5_clear_display();
		ts5_printf(0.0, 20.0, "response %d", resp);
		ts5_printf(0.0, 0.0, "rt %f", rt);
		ts5_printf(0.0, -20.0, "measurement error %f", error);
		ts5_flip_display();
		
		ts5_wait(2.0);		
	}
	
	ts5_draw_mouse_button(ts5_relative_to_absolute_coordinate_x(0.9), ts5_relative_to_absolute_coordinate_y(-0.8));	
	return 0;
}