#include <tscope5.h>

int main()
{
	ts5_install_display();
	ts5_wait(2.0);
	ts5_define_keyboard_key(TS5_KEY_S);
	ts5_define_keyboard_key(TS5_KEY_D);
	ts5_define_keyboard_key(TS5_KEY_K);
	ts5_define_keyboard_key(TS5_KEY_L);
		
	double start;
	double stop1, rt1, error1;
	double stop2, rt2, error2;

	int i;
	for (i=0; i<5; i++) {
		
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "+");
		ts5_flip_display();
		
		unsigned int stim = ts5_random_integer(2);
		if (stim==0) {
			stim='S';
		}
		else {
			stim='L';
		}
		
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "%c", stim);
		ts5_wait(0.5);
		ts5_flush_responses();
		start = ts5_flip_display();
		
		int resp1 = ts5_wait_for_response_until(&stop1, &error1, start + 2.0);
		ts5_hide_response_key(resp1);
		int resp2 = ts5_wait_for_response_until(&stop2, &error2, start + 2.0);
		ts5_hide_response_key(0);

		rt1 = stop1-start;
		rt2 = stop2-start;
		
		ts5_clear_display();
		int align = ts5_set_text_alignment(TS5_ALIGN_LEFT);
		ts5_printf(-200.0, 20.0, "responses: %d %d", resp1, resp2);
		ts5_printf(-200.0, 0.0, "rts: %f %f", rt1, rt2);
		ts5_printf(-200.0, -20.0, "measurement errors: %f %f", error1, error2);

		ts5_set_text_alignment(align);

		ts5_flip_display();
		
		ts5_wait(2.0);		
	}
	
	ts5_draw_mouse_button(ts5_relative_to_absolute_coordinate_x(0.9), ts5_relative_to_absolute_coordinate_y(-0.8));	
	return 0;
}