#include <tscope5.h>

int main()
{
	ts5_install_display();
	ts5_wait(2.0);
	ts5_define_keyboard_key(TS5_KEY_S);
	ts5_define_keyboard_key(TS5_KEY_L);
	ts5_define_keyboard_key(-TS5_KEY_S);
	ts5_define_keyboard_key(-TS5_KEY_L);
		
	double start, stop, release, error1, error2;
	int i;
	for (i=0; i<5; i++) {
		
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "+");
		ts5_flip_display();
		
		unsigned int stim = ts5_random_integer(2);
		if (stim==0) {
			stim='S';
		}
		else {
			stim='L';
		}
		ts5_clear_display();
		ts5_printf(0.0, 0.0, "%c", stim);
		start = ts5_flip_display();
		
		ts5_flush_responses();
		ts5_hide_response_key(0);
		ts5_hide_response_key(3);
		ts5_hide_response_key(4);
		int resp = ts5_wait_for_response_timed(&stop, &error1, 2.0);

		ts5_hide_response_key(0);
		ts5_hide_response_key(1);
		ts5_hide_response_key(2);
		ts5_wait_for_response_timed(&release, &error2, 2.0);

		ts5_clear_display();
		ts5_printf(0.0, 30.0, "response %d", resp);
		ts5_printf(0.0, 10.0, "rt %f, error %f", stop-start, error1);
		ts5_printf(0.0, -10.0, "release %f, error %f", release-start, error2);
		ts5_printf(0.0, -30.0, "press time %f", release-stop);
		ts5_flip_display();
		
		ts5_wait(2.0);		
	}
	
	ts5_draw_mouse_button(ts5_relative_to_absolute_coordinate_x(0.9), ts5_relative_to_absolute_coordinate_y(-0.8));	
	return 0;
}