//////////////////////////////////////////////////////////////////////////////
/// \file system.h
/// Declarations of system functions
//////////////////////////////////////////////////////////////////////////////

#pragma once

#include <allegro5/allegro.h>


//////////////////////////////////////////////////////////////////////////////
// display
//////////////////////////////////////////////////////////////////////////////

#define TS5_DISPLAY						ALLEGRO_DISPLAY

#define TS5_WINDOWED					ALLEGRO_WINDOWED
#define TS5_FULLSCREEN					ALLEGRO_FULLSCREEN
#define TS5_FULLSCREEN_WINDOW 			ALLEGRO_FULLSCREEN_WINDOW

#define TS5_VSYNC_WHATEVER				0
#define TS5_VSYNC_ON					1
#define TS5_VSYNC_OFF					2


//////////////////////////////////////////////////////////////////////////////
// graphics
//////////////////////////////////////////////////////////////////////////////

#include <allegro5/allegro_font.h>

#define	TS5_CARTESIAN_COORDINATES		0
#define TS5_DISPLAY_COORDINATES			1

#define	TS5_RELATIVE_COORDINATES		0
#define TS5_ABSOLUTE_COORDINATES		1

#define TS5_COLOR						ALLEGRO_COLOR

#define TS5_FILL_OFF					0
#define TS5_FILL_ON						1

#define TS5_FONT						ALLEGRO_FONT

#define TS5_FONTTYPES					3
#define TS5_FONTSTYLES					4
#define TS5_FONTSIZES					100
#define TS5_NFONTS						(TS5_FONTTYPES * TS5_FONTSTYLES * TS5_FONTSIZES)
#define TS5_USERFONT					TS5_NFONTS+1

#define	TS5_COURIER						0
#define TS5_ARIAL						1
#define	TS5_TIMES 						2

#define	TS5_REGULAR						0
#define TS5_BOLD						1
#define TS5_ITALIC						2
#define TS5_BOLD_ITALIC 				3

#define TS5_ALIGN_LEFT					ALLEGRO_ALIGN_LEFT
#define TS5_ALIGN_CENTER				ALLEGRO_ALIGN_CENTRE
#define TS5_ALIGN_RIGHT					ALLEGRO_ALIGN_RIGHT


//////////////////////////////////////////////////////////////////////////////
// bitmaps
//////////////////////////////////////////////////////////////////////////////

#define TS5_BITMAP						ALLEGRO_BITMAP
#define TS5_PI							ALLEGRO_PI

#define TS5_FLIP_HORIZONTAL 			ALLEGRO_FLIP_HORIZONTAL
#define TS5_FLIP_VERTICAL				ALLEGRO_FLIP_VERTICAL
#define TS5_FLIP_BOTH 					(ALLEGRO_FLIP_HORIZONTAL | ALLEGRO_FLIP_VERTICAL)


//////////////////////////////////////////////////////////////////////////////
// textio
//////////////////////////////////////////////////////////////////////////////

#define TS5_MAX_CHAR 					512
#define TS5_USTR						ALLEGRO_USTR


//////////////////////////////////////////////////////////////////////////////
// keyboard
//////////////////////////////////////////////////////////////////////////////

#define	TS5_KEY_A						ALLEGRO_KEY_A
#define	TS5_KEY_B		  			  	ALLEGRO_KEY_B
#define	TS5_KEY_C		  			  	ALLEGRO_KEY_C
#define	TS5_KEY_D		  			  	ALLEGRO_KEY_D
#define	TS5_KEY_E		  			  	ALLEGRO_KEY_E
#define	TS5_KEY_F		  			  	ALLEGRO_KEY_F
#define	TS5_KEY_G		  			  	ALLEGRO_KEY_G
#define	TS5_KEY_H		  			  	ALLEGRO_KEY_H
#define	TS5_KEY_I		  			  	ALLEGRO_KEY_I
#define	TS5_KEY_J		  			  	ALLEGRO_KEY_J
#define	TS5_KEY_K		  			  	ALLEGRO_KEY_K
#define	TS5_KEY_L		  			  	ALLEGRO_KEY_L
#define	TS5_KEY_M		  			  	ALLEGRO_KEY_M
#define	TS5_KEY_N		  			  	ALLEGRO_KEY_N
#define	TS5_KEY_O		  			  	ALLEGRO_KEY_O
#define	TS5_KEY_P		  			  	ALLEGRO_KEY_P
#define	TS5_KEY_Q		  			  	ALLEGRO_KEY_Q
#define	TS5_KEY_R		  			  	ALLEGRO_KEY_R
#define	TS5_KEY_S		  			  	ALLEGRO_KEY_S
#define	TS5_KEY_T		  			  	ALLEGRO_KEY_T
#define	TS5_KEY_U		  			  	ALLEGRO_KEY_U
#define	TS5_KEY_V		  			  	ALLEGRO_KEY_V
#define	TS5_KEY_W		  			  	ALLEGRO_KEY_W
#define	TS5_KEY_X		  			  	ALLEGRO_KEY_X
#define	TS5_KEY_Y		  			  	ALLEGRO_KEY_Y
#define	TS5_KEY_Z		  			  	ALLEGRO_KEY_Z

#define	TS5_KEY_0		 			   	ALLEGRO_KEY_0
#define	TS5_KEY_1		 			   	ALLEGRO_KEY_1
#define	TS5_KEY_2		 			   	ALLEGRO_KEY_2
#define	TS5_KEY_3		 			   	ALLEGRO_KEY_3
#define	TS5_KEY_4		 			   	ALLEGRO_KEY_4
#define	TS5_KEY_5		 			   	ALLEGRO_KEY_5
#define	TS5_KEY_6		 			   	ALLEGRO_KEY_6
#define	TS5_KEY_7		 			   	ALLEGRO_KEY_7
#define	TS5_KEY_8		 			   	ALLEGRO_KEY_8
#define	TS5_KEY_9		 			   	ALLEGRO_KEY_9

#define	TS5_KEY_PAD_0 					ALLEGRO_KEY_PAD_0
#define	TS5_KEY_PAD_1 					ALLEGRO_KEY_PAD_1
#define	TS5_KEY_PAD_2 					ALLEGRO_KEY_PAD_2
#define	TS5_KEY_PAD_3 					ALLEGRO_KEY_PAD_3
#define	TS5_KEY_PAD_4 					ALLEGRO_KEY_PAD_4
#define	TS5_KEY_PAD_5 					ALLEGRO_KEY_PAD_5
#define	TS5_KEY_PAD_6 					ALLEGRO_KEY_PAD_6
#define	TS5_KEY_PAD_7 					ALLEGRO_KEY_PAD_7
#define	TS5_KEY_PAD_8 					ALLEGRO_KEY_PAD_8
#define	TS5_KEY_PAD_9 					ALLEGRO_KEY_PAD_9

#define	TS5_KEY_F1 						ALLEGRO_KEY_F1
#define	TS5_KEY_F2 						ALLEGRO_KEY_F2
#define	TS5_KEY_F3 						ALLEGRO_KEY_F3
#define	TS5_KEY_F4 						ALLEGRO_KEY_F4
#define	TS5_KEY_F5 						ALLEGRO_KEY_F5
#define	TS5_KEY_F6 						ALLEGRO_KEY_F6
#define	TS5_KEY_F7 						ALLEGRO_KEY_F7
#define	TS5_KEY_F8 						ALLEGRO_KEY_F8
#define	TS5_KEY_F9 						ALLEGRO_KEY_F9
#define	TS5_KEY_F10						ALLEGRO_KEY_F10
#define	TS5_KEY_F11						ALLEGRO_KEY_F11
#define	TS5_KEY_F12						ALLEGRO_KEY_F12

#define	TS5_KEY_ESCAPE 					ALLEGRO_KEY_ESCAPE
#define	TS5_KEY_TILDE  					ALLEGRO_KEY_TILDE
#define	TS5_KEY_MINUS  					ALLEGRO_KEY_MINUS
#define	TS5_KEY_EQUALS 					ALLEGRO_KEY_EQUALS
#define	TS5_KEY_BACKSPACE				ALLEGRO_KEY_BACKSPACE
#define	TS5_KEY_TAB						ALLEGRO_KEY_TAB
#define	TS5_KEY_OPENBRACE  				ALLEGRO_KEY_OPENBRACE
#define	TS5_KEY_CLOSEBRACE 				ALLEGRO_KEY_CLOSEBRACE
#define	TS5_KEY_ENTER					ALLEGRO_KEY_ENTER
#define	TS5_KEY_SEMICOLON  				ALLEGRO_KEY_SEMICOLON
#define	TS5_KEY_QUOTE					ALLEGRO_KEY_QUOTE
#define	TS5_KEY_BACKSLASH  				ALLEGRO_KEY_BACKSLASH
#define	TS5_KEY_BACKSLASH2 				ALLEGRO_KEY_BACKSLASH2
#define	TS5_KEY_COMMA					ALLEGRO_KEY_COMMA
#define	TS5_KEY_FULLSTOP				ALLEGRO_KEY_FULLSTOP
#define	TS5_KEY_SLASH					ALLEGRO_KEY_SLASH
#define	TS5_KEY_SPACE					ALLEGRO_KEY_SPACE

#define	TS5_KEY_INSERT					ALLEGRO_KEY_INSERT
#define	TS5_KEY_DELETE					ALLEGRO_KEY_DELETE
#define	TS5_KEY_HOME					ALLEGRO_KEY_HOME
#define	TS5_KEY_END						ALLEGRO_KEY_END
#define	TS5_KEY_PGUP					ALLEGRO_KEY_PGUP
#define	TS5_KEY_PGDN					ALLEGRO_KEY_PGDN
#define	TS5_KEY_LEFT					ALLEGRO_KEY_LEFT
#define	TS5_KEY_RIGHT					ALLEGRO_KEY_RIGHT
#define	TS5_KEY_UP						ALLEGRO_KEY_UP
#define	TS5_KEY_DOWN					ALLEGRO_KEY_DOWN

#define	TS5_KEY_PAD_SLASH				ALLEGRO_KEY_PAD_SLASH
#define	TS5_KEY_PAD_ASTERISK			ALLEGRO_KEY_PAD_ASTERISK
#define	TS5_KEY_PAD_MINUS				ALLEGRO_KEY_PAD_MINUS
#define	TS5_KEY_PAD_PLUS				ALLEGRO_KEY_PAD_PLUS
#define	TS5_KEY_PAD_DELETE				ALLEGRO_KEY_PAD_DELETE
#define	TS5_KEY_PAD_ENTER				ALLEGRO_KEY_PAD_ENTER

#define	TS5_KEY_PRINTSCREEN				ALLEGRO_KEY_PRINTSCREEN
#define	TS5_KEY_PAUSE					ALLEGRO_KEY_PAUSE

#define	TS5_KEY_ABNT_C1					ALLEGRO_KEY_ABNT_C1
#define	TS5_KEY_YEN						ALLEGRO_KEY_YEN
#define	TS5_KEY_KANA					ALLEGRO_KEY_KANA
#define	TS5_KEY_CONVERT					ALLEGRO_KEY_CONVERT
#define	TS5_KEY_NOCONVERT  				ALLEGRO_KEY_NOCONVERT
#define	TS5_KEY_AT						ALLEGRO_KEY_AT
#define	TS5_KEY_CIRCUMFLEX 				ALLEGRO_KEY_CIRCUMFLEX
#define	TS5_KEY_COLON2					ALLEGRO_KEY_COLON2
#define	TS5_KEY_KANJI					ALLEGRO_KEY_KANJI

#define	TS5_KEY_PAD_EQUALS 				ALLEGRO_KEY_PAD_EQUALS
#define	TS5_KEY_BACKQUOTE  				ALLEGRO_KEY_BACKQUOTE
#define	TS5_KEY_SEMICOLON2 				ALLEGRO_KEY_SEMICOLON2
#define	TS5_KEY_COMMAND					ALLEGRO_KEY_COMMAND

#define	TS5_KEY_BACK 					ALLEGRO_KEY_BACK

#define	TS5_KEY_UNKNOWN 				ALLEGRO_KEY_UNKNOWN


#define	TS5_KEY_MODIFIERS 				ALLEGRO_KEY_MODIFIERS

#define	TS5_KEY_LSHIFT					ALLEGRO_KEY_LSHIFT
#define	TS5_KEY_RSHIFT					ALLEGRO_KEY_RSHIFT
#define	TS5_KEY_LCTRL					ALLEGRO_KEY_LCTRL
#define	TS5_KEY_RCTRL					ALLEGRO_KEY_RCTRL
#define	TS5_KEY_ALT						ALLEGRO_KEY_ALT
#define	TS5_KEY_ALTGR					ALLEGRO_KEY_ALTGR
#define	TS5_KEY_LWIN					ALLEGRO_KEY_LWIN
#define	TS5_KEY_RWIN					ALLEGRO_KEY_RWIN
#define	TS5_KEY_MENU					ALLEGRO_KEY_MENU
#define	TS5_KEY_SCROLLLOCK				ALLEGRO_KEY_SCROLLLOCK
#define	TS5_KEY_NUMLOCK					ALLEGRO_KEY_NUMLOCK
#define	TS5_KEY_CAPSLOCK  				ALLEGRO_KEY_CAPSLOCK

#define	TS5_KEY_MAX						ALLEGRO_KEY_MAX


//////////////////////////////////////////////////////////////////////////////
// cedrusbox
//////////////////////////////////////////////////////////////////////////////

#define TS5_CEDRUSBOX_MAXPORT			16

#define TS5_CEDRUSBOX_NODEVICE			0
#define TS5_CEDRUSBOX_LUMINA			1
#define TS5_CEDRUSBOX_SV1				2
#define TS5_CEDRUSBOX_RB530				3
#define TS5_CEDRUSBOX_RB730				4
#define TS5_CEDRUSBOX_RB830				5
#define TS5_CEDRUSBOX_RB834				6

#define TS5_CEDRUSBOX_LOCKINGLEVEL		0
#define TS5_CEDRUSBOX_TRESHOLD			1
#define TS5_CEDRUSBOX_MIN_TRESHOLD		2
#define TS5_CEDRUSBOX_MAX_TRESHOLD		3
#define TS5_CEDRUSBOX_RISE_DELAY		4
#define TS5_CEDRUSBOX_MIN_RISE_DELAY	5
#define TS5_CEDRUSBOX_MAX_RISE_DELAY	6
#define TS5_CEDRUSBOX_DROP_DELAY		7

#define TS5_CEDRUSBOX_LOCK				49
#define TS5_CEDRUSBOX_UNLOCK			48

#define TS5_EVENT_CEDRUS_BUTTON_DOWN	 ALLEGRO_GET_EVENT_TYPE ('c', 'e', 'd', 'r')
#define TS5_EVENT_CEDRUS_BUTTON_UP		(TS5_EVENT_CEDRUS_BUTTON_DOWN+1)


//////////////////////////////////////////////////////////////////////////////
// parport
//////////////////////////////////////////////////////////////////////////////

#define TS5_PARPORT_1_DATA				0x378
#define TS5_PARPORT_1_STATUS			0x379
#define TS5_PARPORT_1_CONTROL			0x37A
#define TS5_PARPORT_2_DATA				0x278
#define TS5_PARPORT_2_STATUS			0x279
#define TS5_PARPORT_2_CONTROL			0x27A
#define TS5_PARPORT_3_DATA				0x3BC
#define TS5_PARPORT_3_STATUS			0x3BD
#define TS5_PARPORT_3_CONTROL			0x3BE

#define TS5_EVENT_PARPORT_BUTTON_DOWN	ALLEGRO_GET_EVENT_TYPE ('p', 'a', 'r', 'p')
#define TS5_EVENT_PARPORT_BUTTON_UP		(TS5_EVENT_PARPORT_BUTTON_DOWN+1)
#define TS5_EVENT_PARPORT_TRIGGER		(TS5_EVENT_PARPORT_BUTTON_DOWN+2)


//////////////////////////////////////////////////////////////////////////////
// serialport
//////////////////////////////////////////////////////////////////////////////

#ifdef ALLEGRO_WINDOWS
	#define TS5_SERIALPORT				HANDLE

#else
	#define TS5_SERIALPORT				int

#endif

#define TS5_EVENT_SERIALPORT_TRIGGER	ALLEGRO_GET_EVENT_TYPE ('s', 'e', 'r', 'p')

//////////////////////////////////////////////////////////////////////////////
// audio
//////////////////////////////////////////////////////////////////////////////

#include <allegro5/allegro_audio.h>

#define TS5_VOICE 						ALLEGRO_VOICE
#define TS5_MIXER 						ALLEGRO_MIXER

#define TS5_11025						11025
#define TS5_22050						22050
#define TS5_44100						44100

#define TS5_MONO						1
#define TS5_STEREO						2

#define TS5_INTEGER						ALLEGRO_AUDIO_DEPTH_INT16
#define TS5_FLOAT 						ALLEGRO_AUDIO_DEPTH_FLOAT32


#define TS5_PLAY_ONCE					ALLEGRO_PLAYMODE_ONCE
#define TS5_PLAY_LOOP					ALLEGRO_PLAYMODE_LOOP



//////////////////////////////////////////////////////////////////////////////
// system
//////////////////////////////////////////////////////////////////////////////

#include <allegro5/allegro_native_dialog.h>

#define TS5_LOGLEVEL_0					0
#define TS5_LOGLEVEL_1					1
#define TS5_LOGLEVEL_2					2
#define TS5_LOGLEVEL_3					3
#define TS5_LOGLEVEL_4					4
#define TS5_LOGLEVEL_5					5
#define TS5_LOGLEVEL_6					6


void ts5_log(const unsigned int level, const char *format, ...);
int ts5_set_log_level(const unsigned int loglevel);
int ts5_get_log_level();
void ts5_print_status();
void ts5_fatal(const char *format, ...);

