//////////////////////////////////////////////////////////////////////////////
/// \file textio.h
/// Declarations of text input/output functions
//////////////////////////////////////////////////////////////////////////////

#pragma once

#include "system.h"

double ts5_printf(double x, double y, const char *format, ...);
void ts5_printf_justify(double x1, double x2, double y, const double diff, const char *format, ...);

double ts5_printf_ustr(double x, double y, const TS5_USTR *ustr);
void ts5_printf_justify_ustr(double x1, double x2, double y, const double diff, const TS5_USTR *ustr);

int ts5_scanf(double x, double y, const char *format, ...);

double ts5_get_text_width(const char *format, ...);
double ts5_get_text_width_ustr(TS5_USTR *ustr);

TS5_FONT *ts5_read_font(const char *fontfile, double size);
TS5_FONT *ts5_set_font(TS5_FONT *font);
void ts5_free_font(TS5_FONT *font);

