//////////////////////////////////////////////////////////////////////////////
/// \file keyboard_unittest.c
/// Unit tests of keyboard functions
//////////////////////////////////////////////////////////////////////////////

#include "../include/tscope/keyboard.h"

#include "../include/tscope/display.h"
#include "../include/tscope/timer.h"

//////////////////////////////////////////////////////////////////////////////
/// Keyboard unit tests.
/// - See textiotest for a scanf example
//////////////////////////////////////////////////////////////////////////////
int main(void)
{
	
	ts5_install_display();
		
	// define the keyboard as a response key
	ts5_define_keyboard_key(-TS5_KEY_SPACE);
	ts5_define_keyboard_key(TS5_KEY_MAX-1);
	ts5_print_status();	
	
	double rt, max=100000.0;
	int resp;
	resp = ts5_wait_for_response_timed(&rt, NULL, max);
	printf("response %d %f\n", resp, rt);
	
	return 0;
}
