//////////////////////////////////////////////////////////////////////////////
/// \file parport_unittest.c
/// Unit tests of parport functions
//////////////////////////////////////////////////////////////////////////////

#include "../include/tscope/parport.h"

#include "../include/tscope/timer.h"

#include <tscope.h>
#include <stdio.h>

//////////////////////////////////////////////////////////////////////////////
/// parallel port unit tests.
///
//////////////////////////////////////////////////////////////////////////////
int main(void)
{
	ts5_set_log_level(TS5_LOGLEVEL_5);
	/*
	ts5_define_parport_key(0, 1);
	ts5_define_parport_key(0, 2);

	double rt, err, max=100000.0;
	int resp;

	int i;
	for (i=0; i<5; i++) {
		resp = ts5_wait_for_response_timed(&rt, &err, max);
		printf("response %d %f %f\n", resp, rt, err);
	}
	return 0;
	*/

//	ts5_send_parport_trigger(1, 0.01, (char)123);
	ts5_simulate_parport_trigger_input(1, (unsigned char)255, 0.1);

	ts5_define_parport_trigger_input(1);
	printf("boe\n");

	int trigger=0;
	double trigtime, timing_error;

	int i;
	for (i=0; i<10; i++) {
		do {
			trigger = ts5_check_trigger(&trigtime, &timing_error);
		} while(!trigger);
		printf("trigger %d %f %f\n", trigger, trigtime, timing_error);
	}

	printf("boe\n");
	ts5_write_all_triggers("triggers.txt");

	return 0;
}
