//////////////////////////////////////////////////////////////////////////////
/// \file parport_unittest.c
/// Unit tests of parport functions
//////////////////////////////////////////////////////////////////////////////

#include "../include/tscope/parport.h"

#include "../include/tscope/timer.h"

#include <tscope.h>
#include <stdio.h>

//////////////////////////////////////////////////////////////////////////////
/// parallel port unit tests.
///
//////////////////////////////////////////////////////////////////////////////
int main(void)
{
	ts5_set_log_level(TS5_LOGLEVEL_5);

	ts5_define_serialport_trigger_input("/dev/ttys0");
	ts5_simulate_serialport_trigger_input(1, 255, 0.1);

	printf("boe\n");

	int trigger=0;
	double trigtime, timing_error;

	int i;
	for (i=0; i<10; i++) {
		do {
			trigger = ts5_check_trigger(&trigtime, &timing_error);
		} while(!trigger);
		printf("trigger %d %f %f\n", trigger, trigtime, timing_error);
	}

	printf("boe\n");
	ts5_write_all_triggers("triggers.txt");

	return 0;
}
