//////////////////////////////////////////////////////////////////////////////
/// \file system_unittest.c
/// Unit tests of system functions
//////////////////////////////////////////////////////////////////////////////

#include "../include/tscope/system.h"

//////////////////////////////////////////////////////////////////////////////
/// System functions unit tests.
/// Example of:
/// - writing to the log window
/// - altering the log level
/// - printing out the system state
/// - exit with an error message
///
/// - int 	ts5_set_log_level (const unsigned int loglevel)
/// - int 	ts5_get_log_level ()
/// - void 	ts5_log (const unsigned int level, const char *format,...)
/// - void 	ts5_print_status ()
/// - void 	ts5_fatal (const char *format,...)
//////////////////////////////////////////////////////////////////////////////
int main(void)
{
	ts5_set_log_level(TS5_LOGLEVEL_5);
	ts5_log(TS5_LOGLEVEL_1, "a user-specified log message\n");
	ts5_set_log_level(TS5_LOGLEVEL_5);
	ts5_log(TS5_LOGLEVEL_1, "a user-specified log message\n");
	ts5_print_status();
	ts5_fatal("test finished\n");
	return 0;
}
