//////////////////////////////////////////////////////////////////////////////
/// \file timer_unittest.c
/// Unit tests of timer functions
//////////////////////////////////////////////////////////////////////////////

#include "../include/tscope/timer.h"

#include "../include/tscope/display.h"
#include "../include/tscope/mouse.h"
#include "../include/tscope/keyboard.h"
#include "../include/tscope/joystick.h"
#include "../include/tscope/textio.h"
#include "../include/tscope/graphics.h"

//////////////////////////////////////////////////////////////////////////////
/// timer unit tests.
/// 
//////////////////////////////////////////////////////////////////////////////
int main(void)
{
	ts5_install_display();
	ts5_set_coordinate_system(TS5_DISPLAY_COORDINATES);
	ts5_set_coordinate_scale(TS5_ABSOLUTE_COORDINATES);
	
	ts5_set_text_alignment(TS5_ALIGN_LEFT);
	
	double start, stop;
	
	start = ts5_get_time();
	ts5_wait(1.0);
	stop = ts5_get_time();
	ts5_printf(10.0, 10.0,"start %f", start);
	ts5_printf(10.0, 30.0,"stop %f", stop);
	ts5_printf(10.0, 50.0,"stop-start %f", stop-start);
	ts5_draw_mouse_button(50.0, 100.0);
	ts5_clear_display();
	
	start = ts5_get_time();
	ts5_wait_until(start+1.0);
	stop = ts5_get_time();
	ts5_printf(10.0, 10.0, "start %f", start);
	ts5_printf(10.0, 30.0, "stop %f", stop);
	ts5_printf(10.0, 50.0, "stop-start %f", stop-start);
	ts5_draw_mouse_button(50.0, 100.0);
	ts5_clear_display();
	ts5_flip_display();

	ts5_define_mouse_key(1);
	ts5_flush_responses();
	start = ts5_get_time();
	ts5_wait_for_response_until(&stop, NULL, start+10.0);
	ts5_printf(10.0, 10.0,"start %f", start);
	ts5_printf(10.0, 30.0,"stop %f", stop);
	ts5_printf(10.0, 50.0,"stop-start %f", stop-start);
	ts5_draw_mouse_button(50.0, 100.0);
	
	return 0;
}
